/*
 * Copyright (C) 2005-2013 Schlichtherle IT Services.
 * All rights reserved. Use is subject to license terms.
 */
package net.java.truelicense.core.auth;

import javax.annotation.Nullable;

/**
 * A factory for authenticated objects (artifacts).
 * <p>
 * Implementations need to be immutable and hence thread-safe.
 *
 * @param  <A> The type of the encoded artifact.
 * @author Christian Schlichtherle
 */
public interface Artifactory<A> {
    /**
     * Decodes the artifact from its encoded form.
     *
     * @return A duplicate of the original artifact.
     *         This may be {@code null} if and only if the original artifact
     *         was {@code null}.
     */
    @Nullable A decode() throws Exception;
}
